-#!/usr/bin/python
-import os, shutil, stat, time, subprocess, sys
+#!/usr/bin/python3
+# auto-debuild - Automatic Generation of Debian Packages
+# Copyright (C) 2012 Ralf Jung <post@ralfj.de>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+
+import os, shutil, stat, time, subprocess, sys, shlex, tempfile, argparse, multiprocessing
from collections import OrderedDict
# a dict with some useful additional getters which can convert types and handle one-element lists like their single member
res += "'"+arg+"'"
return res
-# Load a section-less config file: maps parameter names to strings or lists of strings (which are comma-separated or in separate lines)
+# Load a section-less config file: maps parameter names to space-separated lists of strings (with shell quotation)
# Lines starting with spaces are continuation lines
def loadConfigFile(file):
- import shlex
# read config file
linenr = 0
with open(file) as file:
# option line
pos = line.index("=") # will raise exception when substring is not found
curKey = line[:pos].strip()
- value = line[pos+1:]
- result[curKey] = shlex.split(value)
+ result[curKey] = shlex.split(line[pos+1:]) # shlex.split also strips
except Exception:
raise Exception("Invalid config, line %d: Error parsing line (quoting issue?)" % linenr)
# add some convencience get functions
return res
def write(self, f):
- print >>f, "#!/usr/bin/make -f"
- print >>f, ""
- print >>f, ".PHONY: build" # there may be a directory called "build"
- print >>f, ""
- print >>f, "build %:" # need to mention "build" here again explicitly so PHONY takes effect
+ print("#!/usr/bin/make -f", file=f)
+ print(file=f)
+ print(".PHONY: build", file=f) # there may be a directory called "build"
+ print(file=f)
+ print("build %:", file=f) # need to mention "build" here again explicitly so PHONY takes effect
# write proper dh call
dh = self.dh
if self.dhWith:
dh.append('--with='+','.join(self.dhWith))
- print >>f, '\t'+self.env2str()+' dh $@ '+safeCall(*dh)
+ print('\t'+self.env2str()+' dh $@ '+safeCall(*dh), file=f)
# write remaining rules
for rule in self.rules:
- print >>f, ""
- print >>f, "override_dh_"+rule+":"
+ print(file=f)
+ print("override_dh_"+rule+":", file=f)
for line in self.rules[rule]:
- print >>f, "\t"+line
+ print("\t"+line, file=f)
# rule-makers
-def cmakeRules(config):
+def cmakeRules(r, config):
buildDir = config.getstr('buildDir', 'build')
srcDir = os.getcwd()
- r = RulesFile()
r.dh += ["--buildsystem=cmake", "--builddirectory="+buildDir] # dh parameters
r.rules['auto_configure'] = [
safeCall("mkdir", "-p", buildDir),
safeCall("cmake", srcDir, "-DCMAKE_INSTALL_PREFIX=/usr", *config.get('cmakeParameters', []))
]
r.rules['auto_clean'] = [safeCall('rm', '-f', os.path.join(buildDir, 'CMakeCache.txt'))] # clean old cmake cache
- return r
-def automakeRules(config):
+def automakeRules(r, config):
+ buildDir = config.getstr('buildDir', 'build')
+ srcDir = os.getcwd()
# "build" is what we are building *on*, and "host" is what we are building *for* (and GNU is weird...)
- # also, we don't really support cross-building... ;-) (to do, we'd have to write shell code that checks whether BUILD_GNU_TYPE
+ # also, we don't really support cross-building... ;-) (to do so, we'd have to write shell code that checks whether BUILD_GNU_TYPE
# and HOST_GNU_TYPE are equal, and if they are not, add a --host parameter)
- r = RulesFile()
- r.dh += ["--buildsystem=autoconf"]
+ r.dh += ["--buildsystem=autoconf", "--builddirectory="+config.getstr('buildDir')]
r.rules['auto_configure'] = [
+ safeCall("mkdir", "-p", buildDir),
+ safeCall("cd", buildDir) + " && " +
'BUILD_TYPE=$$(dpkg-architecture -qDEB_BUILD_GNU_TYPE) && ' + # doing the expansion beforehand ensures that we cancel if it fails
'MULTIARCH=$$(dpkg-architecture -qDEB_HOST_MULTIARCH) && '+
- './configure --build=$$BUILD_TYPE '+ # do the escape manually here so we can use the variables (there's no user-controlled string in here anyway)
+ safeCall(srcDir+"/configure") +
+ ' --build=$$BUILD_TYPE '+ # do the escape manually here so we can use the variables (there's no user-controlled string in here anyway)
'--prefix=/usr --includedir=/usr/include --mandir=/usr/share/man --infodir=/usr/share/info '+
'--libdir=/usr/lib/$$MULTIARCH --libexecdir=/usr/lib/$$MULTIARCH '+
- '--sysconfdir=/etc --localstatedir=/var '+
- safeCall(*config.get('automakeParameters', []))
+ safeCall('--docdir=/usr/share/doc/'+config['binaryName'], '--sysconfdir=/etc', '--localstatedir=/var', *config.get('automakeParameters', []))
]
- r.rules['auto_clean'] = ['rm -f config.status'] # do not re-use old configuration (no need for escaping here, obviously)
- return r
+ r.rules['auto_clean'] = [safeCall("rm", "-f", "--", buildDir+"/config.status")] # do not re-use old configuration
-def pythonRules(config):
- r = RulesFile()
- r.dh += ["--buildsystem=python_distutils"]
- r.dhWith.add('python2')
- r.rules['auto_clean'] = [ # clean properly
- 'dh_auto_clean',
- 'rm -rf build'
- ]
+def makefileRules(r, config):
+ r.dh += ["--buildsystem=makefile"]
+ r.rules['auto_configure'] = []
+
+def noneRules(r, config):
+ r.dh += ["--buildsystem=makefile"] # makefile does the least possible harm
+ r.rules['auto_configure'] = []
+ r.rules['auto_build'] = []
+ r.rules['auto_clean'] = []
return r
# build systems
buildSystems = {
'cmake': BuildSystem(cmakeRules, ["cmake"]),
'automake': BuildSystem(automakeRules),
- 'python': BuildSystem(pythonRules, ["python-setuptools"], ["${python:Depends}"]),
+ 'makefile': BuildSystem(makefileRules),
+ 'none': BuildSystem(noneRules),
}
# utility functions
def getArchitecture(config):
cmd = commandInBuildEnv(config, ['dpkg-architecture', '-qDEB_HOST_ARCH'])
- p = subprocess.Popen(cmd, stdout=subprocess.PIPE)
- res = p.communicate()[0] # get only stdout
- if p.returncode != 0: raise Exception("Querying dpkg for the architecture failed")
- return res[0:len(res)-1] # chop of the \n at the end
+ with subprocess.Popen(cmd, stdout=subprocess.PIPE) as p:
+ res = p.communicate()[0] # get only stdout
+ if p.returncode != 0: raise Exception("Querying dpkg for the architecture failed")
+ return res.decode('utf-8').strip('\n') # chop of the \n at the end
def writeDependency(f, name, list):
if len(list):
- print >>f, name+": "+', '.join(list)
+ print(name+": "+', '.join(list), file=f)
+
+def deleteDebianFolder():
+ if os.path.islink('debian'):
+ target = os.readlink('debian')
+ if os.path.exists(target):
+ shutil.rmtree(target)
+ os.remove('debian')
+ else:
+ shutil.rmtree('debian')
# actual work functions
def createDebianFiles(config):
config = ConfigDict(config)
sourceName = config.getstr('sourceName')
binaryName = config.getstr('binaryName', sourceName+'-local')
+ config['binaryName'] = binaryName # make it usable by build systems
name = config.getstr('name', os.getenv('USER')) # os.getlogin() fails in minimal chroots
email = config.getstr('email', os.getenv('USER')+'@'+os.uname()[1]) # user@hostname
debDir = os.path.expanduser(config.getstr('debDir'))
buildSystem = buildSystems[config.getstr('buildSystem')] # get the data immediately
- version = config.getstr('version')
+ version = config.getstr('version') # version name excluding epoch (used for filenames)
+ fullVersion = str(config.getint('epoch'))+':'+version if 'epoch' in config else version # version name including epoch
dbgPackage = config.getbool('dbgPackage', False)
- parallelJobs = config.getint('parallelJobs', 2)
+ parallelJobs = config.getint('parallelJobs', multiprocessing.cpu_count()+1)
packageArchitecture = config.getstr('architecture', 'any')
withPython2 = config.getbool('withPython2', False)
+ withSIP = config.getbool('withSIP', False)
+ withAutoreconf = config.getbool('withAutoreconf', False)
+ # add some build dependencies (a bit hacky adding it to the build system...)
+ if withSIP:
+ withPython2 = True
+ buildSystem.buildDepends.append("python-sip")
+ buildSystem.binaryDepends.append("${sip:Depends}")
if withPython2:
- buildSystem.binaryDepends.append("${python:Depends}") # HACK, but it works: make sure dependencies on binary are added
+ buildSystem.buildDepends.append("python")
+ buildSystem.binaryDepends.append("${python:Depends}")
+ if withAutoreconf:
+ buildSystem.buildDepends.append("dh-autoreconf")
# we return the list of files generated, so we need to know the architecture
arch = getArchitecture(config)
files = []
# create folders
- if os.path.exists('debian'): raise Exception('debian folder already exists?')
- os.mkdir('debian')
- os.mkdir('debian/source')
+ if os.path.exists('debian') or os.path.islink('debian'): raise Exception('debian folder already exists?')
+ if config.getbool('useTmp', True):
+ tempdir = tempfile.mkdtemp(prefix='auto-debuild-')
+ os.symlink(tempdir, 'debian')
+ else:
+ os.mkdir('debian')
if not os.path.exists(debDir): os.makedirs(debDir)
# source format file
+ os.mkdir('debian/source')
with open('debian/source/format', 'w') as f:
- print >>f, "3.0 (native)"
+ print("3.0 (native)", file=f)
# compat file
with open('debian/compat', 'w') as f:
- print >>f, "9"
+ print("9", file=f)
# copyright file
with open('debian/copyright', 'w') as f:
- print >>f, "Auto-generated by auto-debuild, not suited for distribution"
+ print("Auto-generated by auto-debuild, not suited for distribution", file=f)
# changelog file
with open('debian/changelog', 'w') as f:
- print >>f, sourceName,"("+version+")","UNRELEASED; urgency=low"
- print >>f, ""
- print >>f, " * Auto-generated by auto-debuild"
- print >>f, ""
- print >>f, " --",name,"<"+email+"> "+time.strftime('%a, %d %b %Y %H:%M:%S %z')
+ print(sourceName,"("+fullVersion+")","UNRELEASED; urgency=low", file=f)
+ print(file=f)
+ print(" * Auto-generated by auto-debuild", file=f)
+ print(file=f)
+ print(" --",name,"<"+email+"> "+time.strftime('%a, %d %b %Y %H:%M:%S %z'), file=f)
# control file
with open('debian/control', 'w') as f:
- print >>f, "Source:",sourceName
- print >>f, "Section:",config.getstr('section', 'misc')
- print >>f, "Priority: extra"
- print >>f, "Maintainer: %s <%s>" % (name, email)
+ # source package
+ print("Source:",sourceName, file=f)
+ print("Section:",config.getstr('section', 'misc'), file=f)
+ print("Priority: extra", file=f)
+ print("Maintainer: %s <%s>" % (name, email), file=f)
writeDependency(f, 'Build-Depends', ["debhelper (>= 9)"] + buildSystem.buildDepends + config.get('buildDepends', []))
- print >>f, "Standards-Version: 3.9.3"
- print >>f, ""
- print >>f, "Package:",binaryName
- print >>f, "Architecture:",packageArchitecture
+ print("Standards-Version: 3.9.3", file=f)
+ # main binary package
+ print(file=f)
+ print("Package:",binaryName, file=f)
+ print("Architecture:",packageArchitecture, file=f)
if 'binaryMultiArch' in config:
- print >>f, "Multi-Arch:",config.getstr('binaryMultiArch')
+ print("Multi-Arch:",config.getstr('binaryMultiArch'), file=f)
writeDependency(f, "Pre-Depends", ["${misc:Pre-Depends}"] + config.get('binaryPreDepends', []))
writeDependency(f, "Depends", ["${shlibs:Depends}", "${misc:Depends}"] + buildSystem.binaryDepends +
config.get('binaryDepends', []))
writeDependency(f, "Conflicts", config.get('binaryConflicts', []))
writeDependency(f, "Breaks", config.get('binaryBreaks', []) + config.get('binaryBreaksReplaces', []))
writeDependency(f, "Replaces", config.get('binaryReplaces', []) + config.get('binaryBreaksReplaces', []))
- print >>f, "Description:",sourceName,"(auto-debuild)"
- print >>f, " Package auto-generated by auto-debuild."
+ print("Description:",sourceName,"(auto-debuild)", file=f)
+ print(" Package auto-generated by auto-debuild.", file=f)
files.append(os.path.join(debDir, "%s_%s_%s.deb" % (binaryName, version, arch)))
+ # debug package
if dbgPackage:
- print >>f, ""
- print >>f, "Package:",binaryName+"-dbg"
- print >>f, "Section: debug"
- print >>f, "Priority: extra"
- print >>f, "Architecture:",packageArchitecture
+ print(file=f)
+ print("Package:",binaryName+"-dbg", file=f)
+ print("Section: debug", file=f)
+ print("Priority: extra", file=f)
+ print("Architecture:",packageArchitecture, file=f)
writeDependency(f, "Depends", ["${misc:Depends}", binaryName+" (= ${binary:Version})"])
- print >>f, "Description:",sourceName,"debug smbols (auto-debuild)"
- print >>f, " Package containing debug symbols for "+sourceName+", auto-generated by auto-debuild."
+ print("Description:",sourceName,"debug smbols (auto-debuild)", file=f)
+ print(" Package containing debug symbols for "+sourceName+", auto-generated by auto-debuild.", file=f)
files.append(os.path.join(debDir, "%s-dbg_%s_%s.deb" % (binaryName, version, arch)))
+ # shim packages
+ for shim in config.get('binaryShims', []):
+ print(file=f)
+ print("Package:",shim, file=f)
+ print("Section:",config.getstr('section', 'misc'), file=f)
+ print("Priority: extra", file=f)
+ print("Architecture:",packageArchitecture, file=f)
+ writeDependency(f, "Depends", ["${misc:Depends}", binaryName+" (= ${binary:Version})"])
+ print("Description:",sourceName,"shim for",shim,"(auto-debuild)", file=f)
+ print(" Package pretending to be "+shim+", auto-generated by auto-debuild.", file=f)
+ files.append(os.path.join(debDir, "%s_%s_%s.deb" % (shim, version, arch)))
# install file
with open('debian/'+binaryName+'.install', 'w') as f:
for line in config.get('binaryInstallFiles', []):
if line.startswith('/'): # a file from within the package, not from the source tree
line = 'debian/'+binaryName+line
- print >>f, line
+ print(line, file=f)
# maintainer scripts for alternatives
if 'alternatives' in config:
with open('debian/'+binaryName+'.postinst', 'w') as f:
- print >>f, "#!/bin/sh"
- print >>f, "set -e"
- print >>f, 'if [ "$1" = "configure" ]; then'
+ print("#!/bin/sh", file=f)
+ print("set -e", file=f)
+ print('if [ "$1" = "configure" ]; then', file=f)
for alternative in config.get('alternatives'):
- print >>f, safeCall('update-alternatives', '--install', alternative['link'], alternative['name'], alternative['target'],
- str(alternative['priority']))
- print >>f, 'fi'
- print >>f, ''
- print >>f, '#DEBHELPER#'
- print >>f, ''
- print >>f, 'exit 0'
+ alternative = shlex.split(alternative)
+ print(safeCall('update-alternatives', '--install', alternative[0], alternative[1], alternative[2], alternative[3]), file=f)
+ print('fi', file=f)
+ print(file=f)
+ print('#DEBHELPER#', file=f)
+ print(file=f)
+ print('exit 0', file=f)
with open('debian/'+binaryName+'.prerm', 'w') as f:
- print >>f, "#!/bin/sh"
- print >>f, "set -e"
- print >>f, 'if [ "$1" = "remove" ]; then'
+ print("#!/bin/sh", file=f)
+ print("set -e", file=f)
+ print('if [ "$1" = "remove" ]; then', file=f)
for alternative in config.get('alternatives'):
- print >>f, safeCall('update-alternatives', '--remove', alternative['name'], alternative['target'])
- print >>f, 'fi'
- print >>f, ''
- print >>f, '#DEBHELPER#'
- print >>f, ''
- print >>f, 'exit 0'
+ alternative = shlex.split(alternative)
+ print(safeCall('update-alternatives', '--remove', alternative[1], alternative[2]), file=f)
+ print('fi', file=f)
+ print(file=f)
+ print('#DEBHELPER#', file=f)
+ print(file=f)
+ print('exit 0', file=f)
# rules file: build system specific
with open('debian/rules', 'w') as f:
- # get rule file for build system: may only touch auto_config and auto_clean rules and the dh options
- r = buildSystem.ruleMaker(config)
+ # pre-fill rule file with our global defaults
+ r = RulesFile()
+ r.rules['auto_test'] = []
+ r.rules['auto_install'] = [safeCall('dh_auto_install', '--destdir=debian/'+binaryName)] # install everything into the binary package
+ r.rules['auto_configure'] = ['dh_auto_configure'] # make sure there is an override (we may just append to it later)
+ # patch rule file for build system: may only touch auto_* rules and the dh options
+ buildSystem.ruleMaker(r, config)
# global rules
r.env["DEB_BUILD_OPTIONS"] = 'parallel='+str(parallelJobs)
if not dbgPackage:
r.dh += ['--parallel']
if withPython2:
r.dhWith.add('python2')
- r.rules['python2'] = ['dh_python2 --no-guessing-versions']
+ r.rules['python2'] = ['dh_python2 --no-guessing-versions --no-shebang-rewrite']
+ if withSIP:
+ r.rules['python2'].append(safeCall('dh_sip', '-p'+binaryName))
+ if withAutoreconf:
+ r.dhWith.add('autoreconf')
r.rules['builddeb'] = [safeCall('dh_builddeb', "--destdir="+debDir)] # passing this gobally to dh results in weird problems (like stuff being installed there, and not in the package...)
- r.rules['auto_test'] = []
# installation rule
- r.rules['auto_install'] = [safeCall('dh_auto_install', '--destdir=debian/'+binaryName)] # install everything into the binary package
if 'binarySkipFiles' in config:
- r.rules['auto_install'].append(safeCall('cd', 'debian/'+binaryName) + " && " +
- safeCall('rm', *config.get('binarySkipFiles')))
- # for debug packages
+ r.rules['auto_install'].append(safeCall('cd', 'debian/'+binaryName) + " && " + safeCall('rm', *config.get('binarySkipFiles')))
+ # debug packages
if dbgPackage:
r.rules['strip'] = [safeCall('dh_strip', '--dbg-package='+binaryName+"-dbg")] # put debug files in appropriate package
- r.rules['installdocs'] = [safeCall('dh_installdocs', '--link-doc='+binaryName)] # make the doc folder of the dbg package a symlink
+ # make the doc folder of the other packages a symlink (dbg, shims)
+ r.rules['installdocs'] = [safeCall('dh_installdocs', '--link-doc='+binaryName)]
# wait after configuration?
if config.getbool('waitAfterConfig', False):
- if not 'auto_configure' in r.rules: r.rules['auto_configure'] = ['dh_auto_configure'] # make sure there is an override
r.rules['auto_configure'].append("@"+safeCall('read', '-p', 'Configuration done. Hit "Enter" to build the package. ', 'DUMMY_VAR')) # if we run in dash, we need to tell it which variable to use for the result...
# dump it to a file
r.write(f)
def buildDebianPackage(config):
if not isinstance(config, ConfigDict):
config = ConfigDict(config)
- commands = ['dpkg-checkbuilddeps', 'debian/rules clean', 'debian/rules build', 'fakeroot debian/rules binary', 'debian/rules clean']
+ commands = ['dpkg-checkbuilddeps', 'debian/rules clean', 'debian/rules build', 'fakeroot debian/rules binary']
command = ['bash', '-c', ' && '.join(commands)] # make it all one command, so we don't have to open and close the chroot too often
subprocess.check_call(commandInBuildEnv(config, command))
- shutil.rmtree('debian') # it only contains what we just created
+ deleteDebianFolder() # cleanup: the debian folder only contains what we just created
###################################################################
# if we are called directly as script
if __name__ == "__main__":
try:
+ # read command-line arguments
+ parser = argparse.ArgumentParser(description='Automatic Generation of Debian Packages')
+ parser.add_argument("-w", "--wait-after-config",
+ action="store_true", dest="wait_after_config",
+ help="Wait for user confirmation after configuration is finished")
+ args = parser.parse_args()
# get config
config = loadConfigFile('auto-debuild.conf')
+ config['waitAfterConfig'] = args.wait_after_config
# generate debian files
- if os.path.exists('debian'):
- if raw_input("A debian folder already exists, to you want to remove it (y/N)? ").lower() != "y":
+ if os.path.exists('debian') or os.path.islink('debian'):
+ if input("A debian folder already exists, do you want to remove it and whatever it links to (y/N)? ").lower() != "y":
sys.exit(1)
- shutil.rmtree('debian')
+ deleteDebianFolder()
files = createDebianFiles(config)
# check if a file is overwritten
for file in files:
if os.path.exists(file):
- if raw_input("Do you want to overwrite %s (y/N)? " % file).lower() != "y":
+ if input("Do you want to overwrite %s (y/N)? " % file).lower() != "y":
sys.exit(1)
# run compilation
buildDebianPackage(config)
# install files
- print "Installing created deb files..."
+ print("Installing created deb files...")
subprocess.check_call(['sudo', 'dpkg', '--install'] + files)
except (subprocess.CalledProcessError, KeyboardInterrupt) as e: # for some exceptions, a stackrace is usually pointless
- print >> sys.stderr
- print >> sys.stderr
+ print(file=sys.stderr)
+ print(file=sys.stderr)
if isinstance(e, KeyboardInterrupt): # str(e) would be the empty string
- print >> sys.stderr, "Interruped by user"
+ print("Interruped by user", file=sys.stderr)
else:
- print >> sys.stderr, "Error during package creation: %s" % str(e)
- print >> sys.stderr
+ print("Error during package creation: %s" % str(e), file=sys.stderr)
+ print(file=sys.stderr)
sys.exit(1)